## asl 0.1.7

=== CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


project(ASL)

# After switching to 3.1 - remove FindOpenCL.cmake from the distribution
# since it is supported by the cmake itself.
cmake_minimum_required(VERSION 3.0.2 FATAL_ERROR)

# Set version number
set(ASL_VERSION_MAJOR 0)
set(ASL_VERSION_MINOR 1)
set(ASL_VERSION_PATCH 7)

set(ASL_VERSION ${ASL_VERSION_MAJOR}.${ASL_VERSION_MINOR}.${ASL_VERSION_PATCH})

if (CMAKE_VERSION VERSION_LESS 3.1.0)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -std=c++11")
else()
	set(CMAKE_CXX_STANDARD 11)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
endif()

# Enable supplied cmake includes and modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Add ASL cmake definitions
include(ASLPaths)
include(ASLBuildOptions)
include(ASLBuildFunctions)

# Find dependencies
find_package(OpenCL 1.1 REQUIRED)
# ToDo: check - system component might be not needed any longer on new versions of Boost
find_package(Boost 1.53 REQUIRED COMPONENTS program_options filesystem system)
# ToDo: remove support for VTK 6.1 at some point in future
find_package(VTK 6.1 QUIET COMPONENTS vtkRenderingCore vtkImagingCore vtkFiltersCore vtkIOCore vtkIOGeometry vtkIOLegacy vtkIOXML vtkIOMINC vtkCommonCore vtkViewsCore vtkftgl vtksys vtkDICOMParser vtkexpat vtkzlib NO_MODULE)
if(NOT VTK_FOUND)
	find_package(VTK 7.0 REQUIRED COMPONENTS vtkRenderingCore vtkImagingCore vtkFiltersCore vtkIOCore vtkIOGeometry vtkIOLegacy vtkIOXML vtkIOMINC vtkCommonCore vtkViewsCore vtksys vtkDICOMParser vtkexpat vtkzlib NO_MODULE)
endif()
include(${VTK_USE_FILE})

include_directories(SYSTEM ${OpenCL_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

add_subdirectory(src)
add_subdirectory(utilities)

if (WITH_EXAMPLES)
	add_subdirectory(examples)
endif()

if (WITH_API_DOC)
	add_subdirectory(doc)
endif()

if (WITH_TESTS)
	# Test labels:
	# DoublePrecision - tests that use double precision (will fail if device does not support it)
	# IO - Input/Output tests (disabled for now)
	# Performance - performance tests
	#
	# Run them e.g.: `ctest [-C Release|Debug] -L Performance`
	# Exclude some of them: `ctest -LE DoublePrecision -LE Performance`
	enable_testing()
	add_subdirectory(test)
endif()

# Packaging
set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_PACKAGE_VERSION_MAJOR ${ASL_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${ASL_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${ASL_VERSION_PATCH})
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Advanced Simulation Library is a free and open source hardware accelerated multiphysics simulation platform.")
set(CPACK_PACKAGE_DESCRIPTION "Advanced Simulation Library (ASL) is a free and open source hardware accelerated multiphysics simulation platform (and an extensible general purpose tool for solving Partial Differential Equations). Its computational engine is written in OpenCL and utilizes matrix-free solution techniques which enable extraordinarily high performance, memory efficiency and deployability on a variety of massively parallel architectures, ranging from inexpensive FPGAs, DSPs and GPUs up to heterogeneous clusters and supercomputers. The engine is hidden entirely behind simple C++ classes, so that no OpenCL knowledge is required from application programmers. Mesh-free, immersed boundary approach allows to move from CAD directly to simulation drastically reducing pre-processing efforts and amount of potential errors. ASL can be used to model various coupled physical and chemical phenomena and employed in a multitude of fields: computational fluid dynamics, virtual sensing, industrial process data validation and reconciliation, image-guided surgery, computer-aided engineering, design space exploration, crystallography, etc..")
set(CPACK_PACKAGE_VENDOR "Avtech Scientific")
set(CPACK_PACKAGE_CONTACT "http://avtechscientific.com/contact")

## .deb-specific
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "http://asl.org.il")
set(CPACK_DEBIAN_PACKAGE_SECTION "science")
set(CPACK_DEBIAN_PACKAGE_SUGGESTS "paraview")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}\n${CPACK_PACKAGE_DESCRIPTION}")

## .rpm-specific
set(CPACK_RPM_PACKAGE_URL "http://asl.org.il")

## NSIS-specific
set(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\asl.org.il")

include(CPack)


# Config (after package definitions, because CPACK_PACKAGE_DESCRIPTION_SUMMARY
# is used for pkgconfig.

## ASLConfig.cmake
include(CMakePackageConfigHelpers)

# ASL conforms to Semantic Versioning scheme <http://semver.org/>
# Switch to COMPATIBILITY SameMajorVersion on ASL_VERSION 1.0.0
# Till then use COMPATIBILITY ExactVersion 
write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/ASLConfigVersion.cmake"
	VERSION ${ASL_VERSION}
	COMPATIBILITY ExactVersion
)

export(EXPORT ASLTargets
	FILE "${CMAKE_CURRENT_BINARY_DIR}/ASLTargets.cmake"
	NAMESPACE ASL::
)

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/ASL)

configure_package_config_file(
	${CMAKE_SOURCE_DIR}/cmake/ASLConfig.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/ASLConfig.cmake
	INSTALL_DESTINATION ${ConfigPackageLocation}
)

install(EXPORT ASLTargets
	FILE
	ASLTargets.cmake
	NAMESPACE
	ASL::
	DESTINATION
	${ConfigPackageLocation}
)

install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/ASLConfig.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/ASLConfigVersion.cmake"
	DESTINATION
	${ConfigPackageLocation}
	COMPONENT
	Devel
)


## ASL.pc

### Read the composed list of all sublibs from the ASL_SUBLIBS_GLOBAL_PROPERTY
get_property(ASL_SUBLIBS GLOBAL PROPERTY ASL_SUBLIBS_GLOBAL_PROPERTY)

configure_file(
	${CMAKE_SOURCE_DIR}/cmake/ASL.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/ASL.pc
	@ONLY
)

install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/ASL.pc
	DESTINATION
	${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== examples/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
#
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


add_subdirectory(flow)
add_subdirectory(elastic)
add_subdirectory(levelSet)
add_subdirectory(jumpingObjects)
add_subdirectory(heatTransfer)
add_subdirectory(massTransferSM)

=== src/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


# ToDo: recheck here and everywhere whether all listed
# _PUBLIC_HEADERS are indeed needed and if not move them
# to the _SOURCES (or _PRIVATE_HEADERS?)

add_subdirectory(acl)
add_subdirectory(num)
add_subdirectory(numExtend)

include(data/asldata.cmake)
include(math/aslmath.cmake)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/acl)


# aslcommon

set(aslcommon_PUBLIC_HEADERS
	utilities/aslTimeStamp.h
	aslUtilities.h
)

set(aslcommon_SOURCES
	utilities/aslTimeStamp.cxx
	aslUtilities.cxx
)

add_library(aslcommon ${aslcommon_PUBLIC_HEADERS} ${aslcommon_SOURCES})
target_link_libraries(aslcommon PRIVATE ${OpenCL_LIBRARIES})
INSTALL_SUBLIB(aslcommon aslcommon_PUBLIC_HEADERS)


# asl

set(asl_PUBLIC_HEADERS
	${asldata_PUBLIC_HEADERS}
	${aslmath_PUBLIC_HEADERS}
	aslGenerators.h
	utilities/aslParametersManager.h
	utilities/aslTimer.h
	utilities/aslUValue.h
	utilities/aslGlobalSpace.h
	utilities/aslSmartPtrUtils.h
	writers/aslABDFormat.h
	writers/aslWriter.h
	aslDataInc.h
	aslGeomInc.h
)

set(asl_SOURCES
	${asldata_SOURCES}
	${aslmath_SOURCES}
	aslGenerators.cxx
	utilities/aslParametersManager.cxx
	writers/aslABDFormat.cxx
	writers/aslWriter.cxx
	aslDataInc.cxx
	aslGeomInc.cxx
)

add_library(asl ${asl_PUBLIC_HEADERS} ${asl_SOURCES})
target_link_libraries(asl PUBLIC aslcommon aslacl PRIVATE ${Boost_LIBRARIES})
INSTALL_SUBLIB(asl asl_PUBLIC_HEADERS)


# aslvtk

set(aslvtk_PUBLIC_HEADERS
	utilities/aslVTKCasters.h
	utilities/aslVTKDataGenerators.h
	writers/aslVTKFormatWriters.h
	readers/aslVTKFormatReaders.h
)

set(aslvtk_SOURCES
	utilities/aslVTKCasters.cxx
	utilities/aslVTKDataGenerators.cxx
	writers/aslVTKFormatWriters.cxx
	readers/aslVTKFormatReaders.cxx
)

add_library(aslvtk ${aslvtk_PUBLIC_HEADERS} ${aslvtk_SOURCES})
target_link_libraries(aslvtk PRIVATE aslacl asl
	${VTK_LIBRARIES} ${OpenCL_LIBRARIES}
	${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
INSTALL_SUBLIB(aslvtk aslvtk_PUBLIC_HEADERS)


# aslmatio

if (WITH_MATIO)
	find_package(MATIO 1.5.2 REQUIRED)
	include_directories(SYSTEM ${MATIO_INCLUDE_DIRS})

	set(aslmatio_PUBLIC_HEADERS
		utilities/aslMATLABCasters.h
		writers/aslMATFormat.h
	)

	set(aslmatio_SOURCES
		utilities/aslMATLABCasters.cxx
		writers/aslMATFormat.cxx
	)

	add_library(aslmatio ${aslmatio_PUBLIC_HEADERS} ${aslmatio_SOURCES})
	target_link_libraries(aslmatio PRIVATE aslacl ${MATIO_LIBRARIES} ${OpenCL_LIBRARIES})
	INSTALL_SUBLIB(aslmatio aslmatio_PUBLIC_HEADERS)
endif (WITH_MATIO)

=== test/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


add_subdirectory(testABD)
add_subdirectory(testACL)
add_subdirectory(testAGL)
add_subdirectory(testMath)

=== utilities/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


include_directories(${CMAKE_SOURCE_DIR}/src)

# Install asl-hardware
add_executable(asl-hardware asl-hardware.cc)
target_link_libraries(asl-hardware aslacl)
install(TARGETS asl-hardware RUNTIME DESTINATION  ${CMAKE_INSTALL_BINDIR})

=== examples/elastic/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


include_directories(${CMAKE_SOURCE_DIR}/src)


add_executable(poroelastic poroelastic.cc)
target_link_libraries(poroelastic aslnum aslvtk asl)
INSTALL_EXAMPLE(poroelastic poroelastic.cc)

add_executable(cubeIncompressibleGravity cubeIncompressibleGravity.cc)
target_link_libraries(cubeIncompressibleGravity aslnum aslvtk asl)
INSTALL_EXAMPLE(cubeIncompressibleGravity cubeIncompressibleGravity.cc)

add_executable(cubePoroelasticGravity cubePoroelasticGravity.cc)
target_link_libraries(cubePoroelasticGravity aslnum aslvtk asl)
INSTALL_EXAMPLE(cubePoroelasticGravity cubePoroelasticGravity.cc)

add_executable(cubeGravity cubeGravity.cc)
target_link_libraries(cubeGravity aslnum aslvtk asl)
INSTALL_EXAMPLE(cubeGravity cubeGravity.cc)

add_executable(acousticWaves acousticWaves.cc)
target_link_libraries(acousticWaves aslnum aslvtk asl)
INSTALL_EXAMPLE(acousticWaves acousticWaves.cc)

=== examples/flow/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


include_directories(${CMAKE_SOURCE_DIR}/src)


add_executable(flow flow.cc)
target_link_libraries(flow aslnum aslvtk asl)
INSTALL_EXAMPLE(flow flow.cc)

add_executable(flow2 flow2.cc)
target_link_libraries(flow2 aslnum aslvtk asl)
INSTALL_EXAMPLE(flow2 flow2.cc)

add_executable(flow3 flow3.cc)
target_link_libraries(flow3 aslnum aslvtk asl)
INSTALL_EXAMPLE(flow3 flow3.cc)

add_executable(flowRotatingCylinders flowRotatingCylinders.cc)
target_link_libraries(flowRotatingCylinders aslnum aslvtk asl)
INSTALL_EXAMPLE(flowRotatingCylinders flowRotatingCylinders.cc)

add_executable(flowKDPGrowth flowKDPGrowth.cc)
target_link_libraries(flowKDPGrowth aslnum aslvtk asl)
INSTALL_EXAMPLE(flowKDPGrowth flowKDPGrowth.cc)

add_executable(locomotive_laminar locomotive_laminar.cc)
target_link_libraries(locomotive_laminar aslnum aslvtk asl)
INSTALL_EXAMPLE(locomotive_laminar locomotive_laminar.cc)

add_executable(compressor compressor.cc)
target_link_libraries(compressor aslnum aslvtk asl)
INSTALL_EXAMPLE(compressor compressor.cc)

add_executable(locomotive locomotive.cc)
target_link_libraries(locomotive aslnum aslvtk asl)
INSTALL_EXAMPLE(locomotive locomotive.cc)

add_executable(locomotive_stability locomotive_stability.cc)
target_link_libraries(locomotive_stability aslnum aslvtk asl)
INSTALL_EXAMPLE(locomotive_stability locomotive_stability.cc)

add_executable(bus_wind bus_wind.cc)
target_link_libraries(bus_wind aslnum aslvtk asl)
INSTALL_EXAMPLE(bus_wind bus_wind.cc)

add_executable(multiphase_flow multiphase_flow.cc)
target_link_libraries(multiphase_flow aslnum aslvtk asl)
INSTALL_EXAMPLE(multiphase_flow multiphase_flow.cc)

add_executable(multicomponent_flow multicomponent_flow.cc)
target_link_libraries(multicomponent_flow aslnum aslvtk asl)
INSTALL_EXAMPLE(multicomponent_flow multicomponent_flow.cc)

add_executable(pitot_tube_ice pitot_tube_ice.cc)
target_link_libraries(pitot_tube_ice aslnum aslvtk asl)
INSTALL_EXAMPLE(pitot_tube_ice pitot_tube_ice.cc)

=== examples/jumpingObjects/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


include_directories(${CMAKE_SOURCE_DIR}/src)

add_executable(jumpingBox jumpingBox.cc)
target_link_libraries(jumpingBox aslnum aslvtk asl)
INSTALL_EXAMPLE(jumpingBox jumpingBox.cc)

=== examples/levelSet/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


include_directories(${CMAKE_SOURCE_DIR}/src)


add_executable(levelSetBasic levelSetBasic.cc)
target_link_libraries(levelSetBasic aslnum aslvtk asl)
INSTALL_EXAMPLE(levelSetBasic levelSetBasic.cc)

add_executable(levelSetNormalGrowth levelSetNormalGrowth.cc)
target_link_libraries(levelSetNormalGrowth aslnum aslvtk asl)
INSTALL_EXAMPLE(levelSetNormalGrowth levelSetNormalGrowth.cc)

add_executable(levelSetFacetedGrowth levelSetFacetedGrowth.cc)
target_link_libraries(levelSetFacetedGrowth aslnum aslvtk asl)
INSTALL_EXAMPLE(levelSetFacetedGrowth levelSetFacetedGrowth.cc levelSetFacetedGrowth.ini)

=== src/acl/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


include(Operators/acloperators.cmake)
include(aclMath/aclmath.cmake)
include(DataTypes/acldatatypes.cmake)
include(Kernels/aclkernels.cmake)

include_directories(${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/acl)


# aslacl

set(aslacl_PUBLIC_HEADERS
	${acloperators_PUBLIC_HEADERS}
	${aclmath_PUBLIC_HEADERS}
	${acldatatypes_PUBLIC_HEADERS}
	${aclkernels_PUBLIC_HEADERS}
	aclStdIncludes.h 
	aclTypesList.h 
	aclTypes.h 
	acl.h
	cl.hpp
	aclHardware.h
	aclUtilities.h
	aclElementBase.h
	aclGenerators.h
)

set(aslacl_SOURCES
	${acloperators_SOURCES}
	${aclmath_SOURCES}
	${acldatatypes_SOURCES}
	${aclkernels_SOURCES}
	acl.cxx 
	aclHardware.cxx
	aclUtilities.cxx 
	aclElementBase.cxx
	aclGenerators.cxx
)

add_library(aslacl ${aslacl_PUBLIC_HEADERS} ${aslacl_SOURCES})
target_link_libraries(aslacl PUBLIC aslcommon ${OpenCL_LIBRARIES})
INSTALL_SUBLIB(aslacl aslacl_PUBLIC_HEADERS)

=== src/num/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


include_directories(${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/acl)


# aslnum

set(aslnum_PUBLIC_HEADERS
	aslNumMethod.h
	aslSingleKernelNM.h	
	aslFDAdvectionDiffusion.h
	aslFDAdvectionDiffusionBC.h
	aslFDStefanMaxwell.h
	aslFDElChemKinetics.h
	aslFDMultiPhase.h
	aslFDAdvectionDiffusion2.h
	aslFDAdvectionDiffusionInhomogeneous.h
	aslLBGK.h
	aslLBGKBC.h
	aslFDElasticity.h
	aslFDPoroElasticity.h
	aslFDPoroElasticityBC.h
	aslBCond.h
	aslBasicBC.h
	aslBasicBC2.h
	aslCrystalGrowthBC.h
	aslNumMethodsMerger.h
	aslFDElasticityBC.h
	aslLevelSet.h
	aslLevelSetLinear.h
	aslDFOptimizer.h
	aslLSNormalGrowth.h
	aslInterfaceTrackingAlg1.h
	aslLSFacetedGrowth.h
	aslTimeContinuations.h
	aslDataResampling.h
)

set(aslnum_SOURCES
	aslNumMethod.cxx
	aslSingleKernelNM.cxx
	aslFDAdvectionDiffusion.cxx
	aslFDAdvectionDiffusionBC.cxx
	aslFDStefanMaxwell.cxx
	aslFDElChemKinetics.cxx
	aslFDMultiPhase.cxx
	aslFDAdvectionDiffusion2.cxx
	aslFDAdvectionDiffusionInhomogeneous.cxx
	aslLBGK.cxx
	aslLBGKBC.cxx
	aslFDElasticity.cxx
	aslFDPoroElasticity.cxx
	aslFDPoroElasticityBC.cxx
	aslBCond.cxx
	aslBasicBC.cxx
	aslBasicBC2.cxx
	aslCrystalGrowthBC.cxx
	aslFDElasticityBC.cxx
	aslNumMethodsMerger.cxx
	aslLevelSet.cxx
	aslLevelSetLinear.cxx
	aslDFOptimizer.cxx
	aslInterfaceTrackingAlg1.cxx
	aslLSNormalGrowth.cxx
	aslLSFacetedGrowth.cxx
	aslTimeContinuations.cxx
	aslDataResampling.cxx
)

add_library(aslnum ${aslnum_PUBLIC_HEADERS} ${aslnum_SOURCES})
target_link_libraries(aslnum PRIVATE asl aslacl aslcommon ${OpenCL_LIBRARIES})
INSTALL_SUBLIB(aslnum aslnum_PUBLIC_HEADERS)

=== test/testABD/CMakeLists.txt ===
#
# Advanced Simulation Library <http://asl.org.il>
# 
# Copyright 2015 Avtech Scientific <http://avtechscientific.com>
#
#
# This file is part of Advanced Simulation Library (ASL).
#
# ASL is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the License.
#
# ASL is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with ASL. If not, see <http://www.gnu.org/licenses/>.
#


include_directories(${CMAKE_SOURCE_DIR}/src)

add_executable(testABDFormat testABDFormat.cc)
target_link_libraries(testABDFormat asl aslcommon)
add_test(NAME testABDFormat COMMAND testABDFormat)

=== debian/changelog ===
asl (0.1.7-5) unstable; urgency=medium

  * Team upload.
  * [d003648] Bump CMake policy version (Closes: #1112709)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 21:37:26 +0200

asl (0.1.7-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.
  * Fix uninstallable packages from the previous upload.

 -- Steve Langasek <vorlon@debian.org>  Wed, 31 Jan 2024 08:04:04 +0000

asl (0.1.7-4) unstable; urgency=medium

  * [e153a88] Compilation against vtk_9.1. (Closes: #1004411)
  * [58428e0] Apply cme fix dpkg. Set Standards-version to 4.6.0
  * [4f44d49] Wrap long lines in changelog entries: 0.1.7-3.
  * [3916f50] Update watch file format version to 4.

 -- Anton Gladky <gladk@debian.org>  Thu, 27 Jan 2022 19:48:46 +0100

asl (0.1.7-3) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Ghislain Antony Vaillant ]
  * [93e4e54] Drop myself from uploaders

  [ Anton Gladky ]
  * [11f6b6d] Add .gitlab-ci.yml
  * [192743a] Bump debhelper from old 10 to 13.
  * [cdb5e85] Set debhelper-compat version in Build-Depends.
  * [07981f8] Set field Upstream-Contact in debian/copyright.
  * [b9b6b72] Update Vcs-* headers from URL redirect.
  * [4e7f943] Use canonical URL in Vcs-Git.
  * [96921be] Remove obsolete field Contact from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * [20d693d] Avoid explicitly specifying -Wl,--as-needed linker flag.
  * [6a05913] Switch to vtk9
  * [049a95d] Add lintian-overrides

 -- Anton Gladky <gladk@debian.org>  Sat, 18 Sep 2021 22:04:21 +0200

asl (0.1.7-2) unstable; urgency=medium

  * Cherry-pick and install upstream manpages.
    - New patch Add-upstream-manpages.patch.
    - Use pandoc to generate the manpages.
    - Install and clean pandoc artefacts.
    - Remove lintian override for missing manpages.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 02 Dec 2016 14:22:59 +0000

asl (0.1.7-1) unstable; urgency=medium

  * Update patch queue.
    - Drop Explicitly-define-namespace-of-ifstream-and-ofstream.patch,
      applied upstream.
    - Drop Replace-includes-math.h-cmath.patch, applied upstream.
    - Refresh Use-system-MathJax.patch.
    - New patch Fix-spelling-errors-reported-by-Lintian.patch.
  * Update list of build dependencies.
  * Upgrade packaging to debhelper 10.
  * Replace occurrences of .md files with .org.
  * Drop build of unused examples and tests.
  * Use DEB_HOST_MULTIARCH for multiarch path injection.
  * Keep the doxygen generated instance of jQuery.
  * Update the description of all binary packages.
  * Provide utilities in new asl-tools package.
  * Rename libasl-doc package to asl-doc.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 24 Nov 2016 18:49:25 +0000

=== debian/control ===
Source: asl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libmatio-dev,
               libvtk9-dev,
               ocl-icd-opencl-dev | opencl-dev,
               pandoc
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/asl
Vcs-Git: https://salsa.debian.org/science-team/asl.git
Homepage: http://asl.org.il

Package: libasl0t64
Provides: ${t64:Provides}
Replaces: libasl0
Breaks: libasl0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: multiphysics simulation software
 The Advanced Simulation Library (ASL) is a free and open source hardware
 accelerated multiphysics simulation platform (and an extensible general
 purpose tool for solving Partial Differential Equations).
 .
 Its computational engine is written in OpenCL and utilizes matrix-free
 solution techniques which enable extraordinarily high performance,
 memory efficiency and deployability on a variety of massively parallel
 architectures, ranging from inexpensive FPGAs, DSPs and GPUs up to
 heterogeneous clusters and supercomputers. The engine is hidden entirely
 behind simple C++ classes, so that no OpenCL knowledge is required from
 application programmers. Mesh-free, immersed boundary approach allows one
 to move from CAD directly to simulation drastically reducing pre-processing
 efforts and amount of potential errors.
 .
 ASL can be used to model various coupled physical and chemical phenomena and
 employed in a multitude of fields: computational fluid dynamics, virtual
 sensing, industrial process data validation and reconciliation, image-guided
 surgery, computer-aided engineering, design space exploration,
 crystallography, etc...
 .
 This package contains the shared libraries.

Package: libasl-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libasl0t64 (= ${binary:Version})
Suggests: asl-doc
Description: development files for ASL
 The Advanced Simulation Library (ASL) is a free and open source hardware
 accelerated multiphysics simulation platform (and an extensible general
 purpose tool for solving Partial Differential Equations).
 .
 Its computational engine is written in OpenCL and utilizes matrix-free
 solution techniques which enable extraordinarily high performance,
 memory efficiency and deployability on a variety of massively parallel
 architectures, ranging from inexpensive FPGAs, DSPs and GPUs up to
 heterogeneous clusters and supercomputers. The engine is hidden entirely
 behind simple C++ classes, so that no OpenCL knowledge is required from
 application programmers. Mesh-free, immersed boundary approach allows one
 to move from CAD directly to simulation drastically reducing pre-processing
 efforts and amount of potential errors.
 .
 ASL can be used to model various coupled physical and chemical phenomena and
 employed in a multitude of fields: computational fluid dynamics, virtual
 sensing, industrial process data validation and reconciliation, image-guided
 surgery, computer-aided engineering, design space exploration,
 crystallography, etc...
 .
 This package contains the development files.

Package: asl-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Breaks: libasl-doc (<< 0.1.7)
Replaces: libasl-doc (<< 0.1.7)
Description: documentation for ASL
 The Advanced Simulation Library (ASL) is a free and open source hardware
 accelerated multiphysics simulation platform (and an extensible general
 purpose tool for solving Partial Differential Equations).
 .
 Its computational engine is written in OpenCL and utilizes matrix-free
 solution techniques which enable extraordinarily high performance,
 memory efficiency and deployability on a variety of massively parallel
 architectures, ranging from inexpensive FPGAs, DSPs and GPUs up to
 heterogeneous clusters and supercomputers. The engine is hidden entirely
 behind simple C++ classes, so that no OpenCL knowledge is required from
 application programmers. Mesh-free, immersed boundary approach allows one
 to move from CAD directly to simulation drastically reducing pre-processing
 efforts and amount of potential errors.
 .
 ASL can be used to model various coupled physical and chemical phenomena and
 employed in a multitude of fields: computational fluid dynamics, virtual
 sensing, industrial process data validation and reconciliation, image-guided
 surgery, computer-aided engineering, design space exploration,
 crystallography, etc...
 .
 This package contains the documentation.

Package: asl-tools
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command-line tools for ASL
 The Advanced Simulation Library (ASL) is a free and open source hardware
 accelerated multiphysics simulation platform (and an extensible general
 purpose tool for solving Partial Differential Equations).
 .
 Its computational engine is written in OpenCL and utilizes matrix-free
 solution techniques which enable extraordinarily high performance,
 memory efficiency and deployability on a variety of massively parallel
 architectures, ranging from inexpensive FPGAs, DSPs and GPUs up to
 heterogeneous clusters and supercomputers. The engine is hidden entirely
 behind simple C++ classes, so that no OpenCL knowledge is required from
 application programmers. Mesh-free, immersed boundary approach allows one
 to move from CAD directly to simulation drastically reducing pre-processing
 efforts and amount of potential errors.
 .
 ASL can be used to model various coupled physical and chemical phenomena and
 employed in a multitude of fields: computational fluid dynamics, virtual
 sensing, industrial process data validation and reconciliation, image-guided
 surgery, computer-aided engineering, design space exploration,
 crystallography, etc...
 .
 This package contains the command-line tools.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture --query DEB_HOST_MULTIARCH)

BUILD_OPTIONS = \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
	-DWITH_EXAMPLES=OFF \
	-DWITH_MATIO=ON \
	-DWITH_TESTS=OFF

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- $(BUILD_OPTIONS) -DWITH_API_DOC=OFF

override_dh_auto_configure-indep:
	dh_auto_configure -- $(BUILD_OPTIONS) -DWITH_API_DOC=ON

override_dh_auto_build-arch:
	dh_auto_build --arch
	pandoc doc/Man-Pages/asl-hardware.1.org -s -t man -o asl-hardware.1

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_installchangelogs:
	dh_installchangelogs NEWS.org

override_dh_compress:
	dh_compress --exclude=examples

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/asl-$1\.tar\.gz/ https://github.com/AvtechScientific/ASL/tags .*/v?(\d\S*)\.tar\.gz
